git-am.shon commit Merge branch 'jn/show-num-walks' (a81f1a8)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [<mbox>|<Maildir>...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  19no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  20c,scissors      strip everything before a scissors line
  21whitespace=     pass it through git-apply
  22ignore-space-change pass it through git-apply
  23ignore-whitespace pass it through git-apply
  24directory=      pass it through git-apply
  25C=              pass it through git-apply
  26p=              pass it through git-apply
  27patch-format=   format the patch(es) are in
  28reject          pass it through git-apply
  29resolvemsg=     override error message when patch failure occurs
  30continue        continue applying patches after resolving a conflict
  31r,resolved      synonyms for --continue
  32skip            skip the current patch
  33abort           restore the original branch and abort the patching operation.
  34committer-date-is-author-date    lie about committer date
  35ignore-date     use current timestamp for author date
  36rerere-autoupdate update the index with reused conflict resolution if possible
  37rebasing*       (internal use for git-rebase)"
  38
  39. git-sh-setup
  40prefix=$(git rev-parse --show-prefix)
  41set_reflog_action am
  42require_work_tree
  43cd_to_toplevel
  44
  45git var GIT_COMMITTER_IDENT >/dev/null ||
  46        die "You need to set your committer info first"
  47
  48if git rev-parse --verify -q HEAD >/dev/null
  49then
  50        HAS_HEAD=yes
  51else
  52        HAS_HEAD=
  53fi
  54
  55cmdline="git am"
  56if test '' != "$interactive"
  57then
  58        cmdline="$cmdline -i"
  59fi
  60if test '' != "$threeway"
  61then
  62        cmdline="$cmdline -3"
  63fi
  64
  65sq () {
  66        git rev-parse --sq-quote "$@"
  67}
  68
  69stop_here () {
  70    echo "$1" >"$dotest/next"
  71    exit 1
  72}
  73
  74stop_here_user_resolve () {
  75    if [ -n "$resolvemsg" ]; then
  76            printf '%s\n' "$resolvemsg"
  77            stop_here $1
  78    fi
  79    echo "When you have resolved this problem run \"$cmdline --resolved\"."
  80    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
  81    echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
  82
  83    stop_here $1
  84}
  85
  86go_next () {
  87        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  88                "$dotest/patch" "$dotest/info"
  89        echo "$next" >"$dotest/next"
  90        this=$next
  91}
  92
  93cannot_fallback () {
  94        echo "$1"
  95        echo "Cannot fall back to three-way merge."
  96        exit 1
  97}
  98
  99fall_back_3way () {
 100    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 101
 102    rm -fr "$dotest"/patch-merge-*
 103    mkdir "$dotest/patch-merge-tmp-dir"
 104
 105    # First see if the patch records the index info that we can use.
 106    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
 107        "$dotest/patch" &&
 108    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 109    git write-tree >"$dotest/patch-merge-base+" ||
 110    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
 111
 112    say Using index info to reconstruct a base tree...
 113    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 114        git apply --cached <"$dotest/patch"
 115    then
 116        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 117        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 118    else
 119        cannot_fallback "Did you hand edit your patch?
 120It does not apply to blobs recorded in its index."
 121    fi
 122
 123    test -f "$dotest/patch-merge-index" &&
 124    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 125    orig_tree=$(cat "$dotest/patch-merge-base") &&
 126    rm -fr "$dotest"/patch-merge-* || exit 1
 127
 128    say Falling back to patching base and 3-way merge...
 129
 130    # This is not so wrong.  Depending on which base we picked,
 131    # orig_tree may be wildly different from ours, but his_tree
 132    # has the same set of wildly different changes in parts the
 133    # patch did not touch, so recursive ends up canceling them,
 134    # saying that we reverted all those changes.
 135
 136    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 137    export GITHEAD_$his_tree
 138    if test -n "$GIT_QUIET"
 139    then
 140            export GIT_MERGE_VERBOSITY=0
 141    fi
 142    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 143            git rerere $allow_rerere_autoupdate
 144            echo Failed to merge in the changes.
 145            exit 1
 146    }
 147    unset GITHEAD_$his_tree
 148}
 149
 150clean_abort () {
 151        test $# = 0 || echo >&2 "$@"
 152        rm -fr "$dotest"
 153        exit 1
 154}
 155
 156patch_format=
 157
 158check_patch_format () {
 159        # early return if patch_format was set from the command line
 160        if test -n "$patch_format"
 161        then
 162                return 0
 163        fi
 164
 165        # we default to mbox format if input is from stdin and for
 166        # directories
 167        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 168        then
 169                patch_format=mbox
 170                return 0
 171        fi
 172
 173        # otherwise, check the first few lines of the first patch to try
 174        # to detect its format
 175        {
 176                read l1
 177                read l2
 178                read l3
 179                case "$l1" in
 180                "From "* | "From: "*)
 181                        patch_format=mbox
 182                        ;;
 183                '# This series applies on GIT commit'*)
 184                        patch_format=stgit-series
 185                        ;;
 186                "# HG changeset patch")
 187                        patch_format=hg
 188                        ;;
 189                *)
 190                        # if the second line is empty and the third is
 191                        # a From, Author or Date entry, this is very
 192                        # likely an StGIT patch
 193                        case "$l2,$l3" in
 194                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 195                                patch_format=stgit
 196                                ;;
 197                        *)
 198                                ;;
 199                        esac
 200                        ;;
 201                esac
 202                if test -z "$patch_format" &&
 203                        test -n "$l1" &&
 204                        test -n "$l2" &&
 205                        test -n "$l3"
 206                then
 207                        # This begins with three non-empty lines.  Is this a
 208                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 209                        # discarding the indented remainder of folded lines,
 210                        # and see if it looks like that they all begin with the
 211                        # header field names...
 212                        tr -d '\015' <"$1" |
 213                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 214                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 215                        patch_format=mbox
 216                fi
 217        } < "$1" || clean_abort
 218}
 219
 220split_patches () {
 221        case "$patch_format" in
 222        mbox)
 223                if test -n "$rebasing" || test t = "$keepcr"
 224                then
 225                    keep_cr=--keep-cr
 226                else
 227                    keep_cr=
 228                fi
 229                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 230                clean_abort
 231                ;;
 232        stgit-series)
 233                if test $# -ne 1
 234                then
 235                        clean_abort "Only one StGIT patch series can be applied at once"
 236                fi
 237                series_dir=`dirname "$1"`
 238                series_file="$1"
 239                shift
 240                {
 241                        set x
 242                        while read filename
 243                        do
 244                                set "$@" "$series_dir/$filename"
 245                        done
 246                        # remove the safety x
 247                        shift
 248                        # remove the arg coming from the first-line comment
 249                        shift
 250                } < "$series_file" || clean_abort
 251                # set the patch format appropriately
 252                patch_format=stgit
 253                # now handle the actual StGIT patches
 254                split_patches "$@"
 255                ;;
 256        stgit)
 257                this=0
 258                for stgit in "$@"
 259                do
 260                        this=`expr "$this" + 1`
 261                        msgnum=`printf "%0${prec}d" $this`
 262                        # Perl version of StGIT parse_patch. The first nonemptyline
 263                        # not starting with Author, From or Date is the
 264                        # subject, and the body starts with the next nonempty
 265                        # line not starting with Author, From or Date
 266                        perl -ne 'BEGIN { $subject = 0 }
 267                                if ($subject > 1) { print ; }
 268                                elsif (/^\s+$/) { next ; }
 269                                elsif (/^Author:/) { print s/Author/From/ ; }
 270                                elsif (/^(From|Date)/) { print ; }
 271                                elsif ($subject) {
 272                                        $subject = 2 ;
 273                                        print "\n" ;
 274                                        print ;
 275                                } else {
 276                                        print "Subject: ", $_ ;
 277                                        $subject = 1;
 278                                }
 279                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 280                done
 281                echo "$this" > "$dotest/last"
 282                this=
 283                msgnum=
 284                ;;
 285        *)
 286                if test -n "$parse_patch" ; then
 287                        clean_abort "Patch format $patch_format is not supported."
 288                else
 289                        clean_abort "Patch format detection failed."
 290                fi
 291                ;;
 292        esac
 293}
 294
 295prec=4
 296dotest="$GIT_DIR/rebase-apply"
 297sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 298resolvemsg= resume= scissors= no_inbody_headers=
 299git_apply_opt=
 300committer_date_is_author_date=
 301ignore_date=
 302allow_rerere_autoupdate=
 303
 304if test "$(git config --bool --get am.keepcr)" = true
 305then
 306    keepcr=t
 307fi
 308
 309while test $# != 0
 310do
 311        case "$1" in
 312        -i|--interactive)
 313                interactive=t ;;
 314        -b|--binary)
 315                : ;;
 316        -3|--3way)
 317                threeway=t ;;
 318        -s|--signoff)
 319                sign=t ;;
 320        -u|--utf8)
 321                utf8=t ;; # this is now default
 322        --no-utf8)
 323                utf8= ;;
 324        -k|--keep)
 325                keep=t ;;
 326        -c|--scissors)
 327                scissors=t ;;
 328        --no-scissors)
 329                scissors=f ;;
 330        -r|--resolved|--continue)
 331                resolved=t ;;
 332        --skip)
 333                skip=t ;;
 334        --abort)
 335                abort=t ;;
 336        --rebasing)
 337                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 338        -d|--dotest)
 339                die "-d option is no longer supported.  Do not use."
 340                ;;
 341        --resolvemsg)
 342                shift; resolvemsg=$1 ;;
 343        --whitespace|--directory)
 344                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 345        -C|-p)
 346                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 347        --patch-format)
 348                shift ; patch_format="$1" ;;
 349        --reject|--ignore-whitespace|--ignore-space-change)
 350                git_apply_opt="$git_apply_opt $1" ;;
 351        --committer-date-is-author-date)
 352                committer_date_is_author_date=t ;;
 353        --ignore-date)
 354                ignore_date=t ;;
 355        --rerere-autoupdate|--no-rerere-autoupdate)
 356                allow_rerere_autoupdate="$1" ;;
 357        -q|--quiet)
 358                GIT_QUIET=t ;;
 359        --keep-cr)
 360                keepcr=t ;;
 361        --no-keep-cr)
 362                keepcr=f ;;
 363        --)
 364                shift; break ;;
 365        *)
 366                usage ;;
 367        esac
 368        shift
 369done
 370
 371# If the dotest directory exists, but we have finished applying all the
 372# patches in them, clear it out.
 373if test -d "$dotest" &&
 374   last=$(cat "$dotest/last") &&
 375   next=$(cat "$dotest/next") &&
 376   test $# != 0 &&
 377   test "$next" -gt "$last"
 378then
 379   rm -fr "$dotest"
 380fi
 381
 382if test -d "$dotest"
 383then
 384        case "$#,$skip$resolved$abort" in
 385        0,*t*)
 386                # Explicit resume command and we do not have file, so
 387                # we are happy.
 388                : ;;
 389        0,)
 390                # No file input but without resume parameters; catch
 391                # user error to feed us a patch from standard input
 392                # when there is already $dotest.  This is somewhat
 393                # unreliable -- stdin could be /dev/null for example
 394                # and the caller did not intend to feed us a patch but
 395                # wanted to continue unattended.
 396                test -t 0
 397                ;;
 398        *)
 399                false
 400                ;;
 401        esac ||
 402        die "previous rebase directory $dotest still exists but mbox given."
 403        resume=yes
 404
 405        case "$skip,$abort" in
 406        t,t)
 407                die "Please make up your mind. --skip or --abort?"
 408                ;;
 409        t,)
 410                git rerere clear
 411                git read-tree --reset -u HEAD HEAD
 412                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 413                git reset HEAD
 414                git update-ref ORIG_HEAD $orig_head
 415                ;;
 416        ,t)
 417                if test -f "$dotest/rebasing"
 418                then
 419                        exec git rebase --abort
 420                fi
 421                git rerere clear
 422                test -f "$dotest/dirtyindex" || {
 423                        git read-tree --reset -u HEAD ORIG_HEAD
 424                        git reset ORIG_HEAD
 425                }
 426                rm -fr "$dotest"
 427                exit ;;
 428        esac
 429        rm -f "$dotest/dirtyindex"
 430else
 431        # Make sure we are not given --skip, --resolved, nor --abort
 432        test "$skip$resolved$abort" = "" ||
 433                die "Resolve operation not in progress, we are not resuming."
 434
 435        # Start afresh.
 436        mkdir -p "$dotest" || exit
 437
 438        if test -n "$prefix" && test $# != 0
 439        then
 440                first=t
 441                for arg
 442                do
 443                        test -n "$first" && {
 444                                set x
 445                                first=
 446                        }
 447                        case "$arg" in
 448                        /*)
 449                                set "$@" "$arg" ;;
 450                        *)
 451                                set "$@" "$prefix$arg" ;;
 452                        esac
 453                done
 454                shift
 455        fi
 456
 457        check_patch_format "$@"
 458
 459        split_patches "$@"
 460
 461        # -i can and must be given when resuming; everything
 462        # else is kept
 463        echo " $git_apply_opt" >"$dotest/apply-opt"
 464        echo "$threeway" >"$dotest/threeway"
 465        echo "$sign" >"$dotest/sign"
 466        echo "$utf8" >"$dotest/utf8"
 467        echo "$keep" >"$dotest/keep"
 468        echo "$keepcr" >"$dotest/keepcr"
 469        echo "$scissors" >"$dotest/scissors"
 470        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 471        echo "$GIT_QUIET" >"$dotest/quiet"
 472        echo 1 >"$dotest/next"
 473        if test -n "$rebasing"
 474        then
 475                : >"$dotest/rebasing"
 476        else
 477                : >"$dotest/applying"
 478                if test -n "$HAS_HEAD"
 479                then
 480                        git update-ref ORIG_HEAD HEAD
 481                else
 482                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 483                fi
 484        fi
 485fi
 486
 487case "$resolved" in
 488'')
 489        case "$HAS_HEAD" in
 490        '')
 491                files=$(git ls-files) ;;
 492        ?*)
 493                files=$(git diff-index --cached --name-only HEAD --) ;;
 494        esac || exit
 495        if test "$files"
 496        then
 497                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 498                die "Dirty index: cannot apply patches (dirty: $files)"
 499        fi
 500esac
 501
 502if test "$(cat "$dotest/utf8")" = t
 503then
 504        utf8=-u
 505else
 506        utf8=-n
 507fi
 508if test "$(cat "$dotest/keep")" = t
 509then
 510        keep=-k
 511fi
 512case "$(cat "$dotest/keepcr")" in
 513t)
 514        keepcr=--keep-cr ;;
 515f)
 516        keepcr=--no-keep-cr ;;
 517esac
 518case "$(cat "$dotest/scissors")" in
 519t)
 520        scissors=--scissors ;;
 521f)
 522        scissors=--no-scissors ;;
 523esac
 524if test "$(cat "$dotest/no_inbody_headers")" = t
 525then
 526        no_inbody_headers=--no-inbody-headers
 527else
 528        no_inbody_headers=
 529fi
 530if test "$(cat "$dotest/quiet")" = t
 531then
 532        GIT_QUIET=t
 533fi
 534if test "$(cat "$dotest/threeway")" = t
 535then
 536        threeway=t
 537fi
 538git_apply_opt=$(cat "$dotest/apply-opt")
 539if test "$(cat "$dotest/sign")" = t
 540then
 541        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 542                        s/>.*/>/
 543                        s/^/Signed-off-by: /'
 544                `
 545else
 546        SIGNOFF=
 547fi
 548
 549last=`cat "$dotest/last"`
 550this=`cat "$dotest/next"`
 551if test "$skip" = t
 552then
 553        this=`expr "$this" + 1`
 554        resume=
 555fi
 556
 557if test "$this" -gt "$last"
 558then
 559        say Nothing to do.
 560        rm -fr "$dotest"
 561        exit
 562fi
 563
 564while test "$this" -le "$last"
 565do
 566        msgnum=`printf "%0${prec}d" $this`
 567        next=`expr "$this" + 1`
 568        test -f "$dotest/$msgnum" || {
 569                resume=
 570                go_next
 571                continue
 572        }
 573
 574        # If we are not resuming, parse and extract the patch information
 575        # into separate files:
 576        #  - info records the authorship and title
 577        #  - msg is the rest of commit log message
 578        #  - patch is the patch body.
 579        #
 580        # When we are resuming, these files are either already prepared
 581        # by the user, or the user can tell us to do so by --resolved flag.
 582        case "$resume" in
 583        '')
 584                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 585                        <"$dotest/$msgnum" >"$dotest/info" ||
 586                        stop_here $this
 587
 588                # skip pine's internal folder data
 589                sane_grep '^Author: Mail System Internal Data$' \
 590                        <"$dotest"/info >/dev/null &&
 591                        go_next && continue
 592
 593                test -s "$dotest/patch" || {
 594                        echo "Patch is empty.  Was it split wrong?"
 595                        echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
 596                        echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
 597                        stop_here $this
 598                }
 599                rm -f "$dotest/original-commit"
 600                if test -f "$dotest/rebasing" &&
 601                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 602                                -e q "$dotest/$msgnum") &&
 603                        test "$(git cat-file -t "$commit")" = commit
 604                then
 605                        git cat-file commit "$commit" |
 606                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 607                        echo "$commit" > "$dotest/original-commit"
 608                else
 609                        {
 610                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 611                                echo
 612                                cat "$dotest/msg"
 613                        } |
 614                        git stripspace > "$dotest/msg-clean"
 615                fi
 616                ;;
 617        esac
 618
 619        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 620        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 621        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 622
 623        if test -z "$GIT_AUTHOR_EMAIL"
 624        then
 625                echo "Patch does not have a valid e-mail address."
 626                stop_here $this
 627        fi
 628
 629        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 630
 631        case "$resume" in
 632        '')
 633            if test '' != "$SIGNOFF"
 634            then
 635                LAST_SIGNED_OFF_BY=`
 636                    sed -ne '/^Signed-off-by: /p' \
 637                    "$dotest/msg-clean" |
 638                    sed -ne '$p'
 639                `
 640                ADD_SIGNOFF=`
 641                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 642                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 643                    echo "$SIGNOFF"
 644                }`
 645            else
 646                ADD_SIGNOFF=
 647            fi
 648            {
 649                if test -s "$dotest/msg-clean"
 650                then
 651                        cat "$dotest/msg-clean"
 652                fi
 653                if test '' != "$ADD_SIGNOFF"
 654                then
 655                        echo "$ADD_SIGNOFF"
 656                fi
 657            } >"$dotest/final-commit"
 658            ;;
 659        *)
 660                case "$resolved$interactive" in
 661                tt)
 662                        # This is used only for interactive view option.
 663                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 664                        ;;
 665                esac
 666        esac
 667
 668        resume=
 669        if test "$interactive" = t
 670        then
 671            test -t 0 ||
 672            die "cannot be interactive without stdin connected to a terminal."
 673            action=again
 674            while test "$action" = again
 675            do
 676                echo "Commit Body is:"
 677                echo "--------------------------"
 678                cat "$dotest/final-commit"
 679                echo "--------------------------"
 680                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 681                read reply
 682                case "$reply" in
 683                [yY]*) action=yes ;;
 684                [aA]*) action=yes interactive= ;;
 685                [nN]*) action=skip ;;
 686                [eE]*) git_editor "$dotest/final-commit"
 687                       action=again ;;
 688                [vV]*) action=again
 689                       git_pager "$dotest/patch" ;;
 690                *)     action=again ;;
 691                esac
 692            done
 693        else
 694            action=yes
 695        fi
 696
 697        if test -f "$dotest/final-commit"
 698        then
 699                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 700        else
 701                FIRSTLINE=""
 702        fi
 703
 704        if test $action = skip
 705        then
 706                go_next
 707                continue
 708        fi
 709
 710        if test -x "$GIT_DIR"/hooks/applypatch-msg
 711        then
 712                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 713                stop_here $this
 714        fi
 715
 716        say "Applying: $FIRSTLINE"
 717
 718        case "$resolved" in
 719        '')
 720                # When we are allowed to fall back to 3-way later, don't give
 721                # false errors during the initial attempt.
 722                squelch=
 723                if test "$threeway" = t
 724                then
 725                        squelch='>/dev/null 2>&1 '
 726                fi
 727                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 728                apply_status=$?
 729                ;;
 730        t)
 731                # Resolved means the user did all the hard work, and
 732                # we do not have to do any patch application.  Just
 733                # trust what the user has in the index file and the
 734                # working tree.
 735                resolved=
 736                git diff-index --quiet --cached HEAD -- && {
 737                        echo "No changes - did you forget to use 'git add'?"
 738                        echo "If there is nothing left to stage, chances are that something else"
 739                        echo "already introduced the same changes; you might want to skip this patch."
 740                        stop_here_user_resolve $this
 741                }
 742                unmerged=$(git ls-files -u)
 743                if test -n "$unmerged"
 744                then
 745                        echo "You still have unmerged paths in your index"
 746                        echo "did you forget to use 'git add'?"
 747                        stop_here_user_resolve $this
 748                fi
 749                apply_status=0
 750                git rerere
 751                ;;
 752        esac
 753
 754        if test $apply_status != 0 && test "$threeway" = t
 755        then
 756                if (fall_back_3way)
 757                then
 758                    # Applying the patch to an earlier tree and merging the
 759                    # result may have produced the same tree as ours.
 760                    git diff-index --quiet --cached HEAD -- && {
 761                        say No changes -- Patch already applied.
 762                        go_next
 763                        continue
 764                    }
 765                    # clear apply_status -- we have successfully merged.
 766                    apply_status=0
 767                fi
 768        fi
 769        if test $apply_status != 0
 770        then
 771                printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
 772                stop_here_user_resolve $this
 773        fi
 774
 775        if test -x "$GIT_DIR"/hooks/pre-applypatch
 776        then
 777                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 778        fi
 779
 780        tree=$(git write-tree) &&
 781        commit=$(
 782                if test -n "$ignore_date"
 783                then
 784                        GIT_AUTHOR_DATE=
 785                fi
 786                parent=$(git rev-parse --verify -q HEAD) ||
 787                say >&2 "applying to an empty history"
 788
 789                if test -n "$committer_date_is_author_date"
 790                then
 791                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 792                        export GIT_COMMITTER_DATE
 793                fi &&
 794                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 795        ) &&
 796        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 797        stop_here $this
 798
 799        if test -f "$dotest/original-commit"; then
 800                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 801        fi
 802
 803        if test -x "$GIT_DIR"/hooks/post-applypatch
 804        then
 805                "$GIT_DIR"/hooks/post-applypatch
 806        fi
 807
 808        go_next
 809done
 810
 811if test -s "$dotest"/rewritten; then
 812    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 813    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 814        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 815    fi
 816fi
 817
 818rm -fr "$dotest"
 819git gc --auto